cpp-common/bt2c/fmt.hpp: use `wise_enum::string_type` in `EnableIfIsWiseEnum` definition
[babeltrace.git] / tests / plugins / src.ctf.lttng-live / test_live
diff --git a/tests/plugins/src.ctf.lttng-live/test_live b/tests/plugins/src.ctf.lttng-live/test_live
deleted file mode 100755 (executable)
index bbda1d3..0000000
+++ /dev/null
@@ -1,377 +0,0 @@
-#!/bin/bash
-#
-# SPDX-License-Identifier: GPL-2.0-only
-#
-# Copyright (C) 2019 Philippe Proulx <pproulx@efficios.com>
-#
-
-# This test validates that a `src.ctf.fs` component successfully reads
-# specific CTF traces and creates the expected messages.
-#
-# Such CTF traces to open either exist (in `tests/ctf-traces/`)
-# or are generated by this test using local trace generators.
-
-SH_TAP=1
-
-if [ "x${BT_TESTS_SRCDIR:-}" != "x" ]; then
-       UTILSSH="$BT_TESTS_SRCDIR/utils/utils.sh"
-else
-       UTILSSH="$(dirname "$0")/../../utils/utils.sh"
-fi
-
-# shellcheck source=../../utils/utils.sh
-source "$UTILSSH"
-
-function cleanup ()
-{
-       # Disable trap for SIGTERM since the following kill to the
-       # pidgroup will be SIGTERM. Otherwise it loops.
-       # The '-' before the pid number ($$) indicates 'kill' to signal the
-       # whole process group.
-       trap - SIGTERM && kill -- -$$
-}
-
-# Ensure that background child jobs are killed on SIGINT/SIGTERM
-trap cleanup SIGINT SIGTERM
-
-this_dir_relative="plugins/src.ctf.lttng-live"
-test_data_dir="$BT_TESTS_DATADIR/$this_dir_relative"
-trace_dir="$BT_CTF_TRACES_PATH"
-
-if [ "$BT_OS_TYPE" = "mingw" ]; then
-       # Same as the above, but in Windows form (C:\foo\bar) instead of Unix form
-       # (/c/foo/bar).
-       trace_dir_native=$(cygpath -w "${trace_dir}")
-else
-       trace_dir_native="${trace_dir}"
-fi
-
-lttng_live_server() {
-       local port_file="$1"
-       local pid_file="$2"
-       local retcode_file="$3"
-       local server_args="$4"
-       local server_script="$test_data_dir/lttng_live_server.py"
-
-       # start server
-       echo "$server_args" | xargs "$BT_TESTS_PYTHON_BIN" "$server_script" \
-               --port-file "$port_file" \
-               --trace-path-prefix "$trace_dir_native" &
-
-       # write PID to file
-       echo $! > "$pid_file"
-
-       # wait for server to exit
-       wait
-
-       # write return code to file
-       echo $? > "$retcode_file"
-}
-
-kill_lttng_live_server() {
-       local pid_file="$1"
-
-       if [ ! -s "$pid_file" ]; then
-               return
-       fi
-
-       kill -9 "$(cat "$pid_file")"
-}
-
-get_cli_output_with_lttng_live_server() {
-       local cli_args_template="$1"
-       local sessions_file="$2"
-       local cli_stdout_file="$3"
-       local cli_stderr_file="$4"
-       local port_file="$5"
-
-       local i
-       local ret
-       local port
-       local cli_args
-       local server_pid_file
-       local server_retcode_file
-
-       server_pid_file="$(mktemp -t test_live_server_pid.XXXXXX)"
-       server_retcode_file="$(mktemp -t test_live_server_ret.XXXXX)"
-
-       diag "Starting LTTng live server mockup"
-
-       # This starts the server, which eventually writes its listening
-       # port number to the `$port_file` file. The lttng_live_server()
-       # function itself writes the server's PID to the
-       # `$server_pid_file` file. When the server exits,
-       # lttng_live_server() writes its return code to the
-       # `$server_retcode_file` file.
-       lttng_live_server "$port_file" "$server_pid_file" \
-               "$server_retcode_file" "$sessions_file" &
-
-       # Get port number
-       i=0
-       while [ ! -s "$port_file" ]; do
-               sleep .1
-
-               # Timeout of 30 seconds
-               if [ "$i" -eq "300" ]; then
-                       # too long, kill it
-                       kill_lttng_live_server "$server_pid_file"
-                       wait
-                       rm -f "$server_pid_file"
-                       rm -f "$server_retcode_file"
-                       return 1
-               fi
-
-               i=$((i + 1))
-       done
-
-       port=$(<"$port_file")
-
-       diag "LTTng live port is $port"
-
-       cli_args=${cli_args_template//@PORT@/$port}
-
-       # Split argument string by spaces into an array.
-       IFS=' ' read -ra cli_args <<< "$cli_args"
-
-       if ! bt_cli "$cli_stdout_file" "$cli_stderr_file" "${cli_args[@]}"; then
-               # CLI failed: cancel everything else
-               kill_lttng_live_server "$server_pid_file"
-               wait
-               rm -f "$server_pid_file"
-               rm -f "$server_retcode_file"
-               return 1
-       fi
-
-       # get server's return code
-       i=0
-       while [ ! -s "$server_retcode_file" ]; do
-               sleep .1
-
-               # Timeout of 30 seconds
-               if [ "$i" -eq "300" ]; then
-                       # too long, kill it
-                       kill_lttng_live_server "$server_pid_file"
-                       wait
-                       rm -f "$server_pid_file"
-                       rm -f "$server_retcode_file"
-                       return 1
-               fi
-
-               i=$((i + 1))
-       done
-
-       wait
-
-       ret=$(<"$server_retcode_file")
-
-       rm -f "$server_pid_file"
-       rm -f "$server_retcode_file"
-       return "$ret"
-}
-
-run_test() {
-       local test_text="$1"
-       local cli_args_template="$2"
-       local server_args="$3"
-       local expected_stdout="$4"
-       local expected_stderr="$5"
-
-       local cli_stderr
-       local cli_stdout
-       local port_file
-       local port
-
-       cli_stderr="$(mktemp -t test_live_stderr.XXXXXX)"
-       cli_stdout="$(mktemp -t test_live_stdout.XXXXXX)"
-       port_file="$(mktemp -t test_live_server_port.XXXXXX)"
-
-       get_cli_output_with_lttng_live_server "$cli_args_template" "$server_args" "$cli_stdout" "$cli_stderr" "$port_file"
-       port=$(<"$port_file")
-
-       bt_diff "$expected_stdout" "$cli_stdout"
-       ok $? "$test_text - stdout"
-       bt_diff "$expected_stderr" "$cli_stderr"
-       ok $? "$test_text - stderr"
-
-       rm -f "$cli_stderr"
-       rm -f "$cli_stdout"
-       rm -f "$port_file"
-}
-
-test_list_sessions() {
-       # Test the basic listing of sessions.
-       # Ensure that a multi-domain trace is seen as a single session.
-       # run_test() is not used here because the port is needed to craft the
-       # expected output.
-
-       local port
-       local port_file
-       local tmp_stdout_expected
-       local template_expected
-
-       local test_text="CLI prints the expected session list"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@"
-       local sessions_file="$test_data_dir/list_sessions.json"
-       local server_args="--sessions-filename '$sessions_file'"
-
-       template_expected=$(<"$test_data_dir/cli-list-sessions.expect")
-       cli_stderr="$(mktemp -t test_live_list_sessions_stderr.XXXXXX)"
-       cli_stdout="$(mktemp -t test_live_list_sessions_stdout.XXXXXX)"
-       empty_file="$(mktemp -t test_live_list_sessions_empty.XXXXXX)"
-       port_file="$(mktemp -t test_live_list_sessions_server_port.XXXXXX)"
-       tmp_stdout_expected="$(mktemp -t test_live_list_sessions_stdout_expected.XXXXXX)"
-
-       get_cli_output_with_lttng_live_server "$cli_args_template" "$server_args" "$cli_stdout" "$cli_stderr" "$port_file"
-       port=$(<"$port_file")
-
-       # Craft the expected output. This is necessary since the port number
-       # (random) of a "relayd" is present in the output.
-       template_expected=${template_expected//@PORT@/$port}
-
-       echo "$template_expected" > "$tmp_stdout_expected"
-
-       bt_diff "$tmp_stdout_expected" "$cli_stdout"
-       ok $? "$test_text - stdout"
-       bt_diff "$empty_file" "$cli_stderr"
-       ok $? "$test_text - stderr"
-
-       rm -f "$cli_stderr"
-       rm -f "$cli_stdout"
-       rm -f "$empty_file"
-       rm -f "$port_file"
-       rm -f "$tmp_stdout_expected"
-}
-
-test_base() {
-       # Attach and consume data from a multi packets ust session with no
-       # discarded events.
-       local test_text="CLI attach and fetch from single-domains session - no discarded events"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@/host/hostname/trace-with-index -c sink.text.details"
-       local sessions_file="$test_data_dir/base.json"
-       local server_args="--sessions-filename '$sessions_file'"
-       local expected_stdout="${test_data_dir}/cli-base.expect"
-       local expected_stderr
-
-       # Empty file for stderr expected
-       expected_stderr="$(mktemp -t test_live_base_stderr_expected.XXXXXX)"
-
-       run_test "$test_text" "$cli_args_template" "$server_args" "$expected_stdout" "$expected_stderr"
-
-       rm -f "$expected_stderr"
-}
-
-test_multi_domains() {
-       # Attach and consume data from a multi-domains session with discarded
-       # events.
-       local test_text="CLI attach and fetch from multi-domains session - discarded events"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@/host/hostname/multi-domains -c sink.text.details"
-       local sessions_file="${test_data_dir}/multi_domains.json"
-       local server_args="--sessions-filename '$sessions_file'"
-       local expected_stdout="$test_data_dir/cli-multi-domains.expect"
-       local expected_stderr
-
-       # Empty file for stderr expected
-       expected_stderr="$(mktemp -t test_live_multi_domains_stderr_expected.XXXXXX)"
-
-       run_test "$test_text" "$cli_args_template" "$server_args" "$expected_stdout" "$expected_stderr"
-
-       rm -f "$expected_stderr"
-}
-
-test_rate_limited() {
-       # Attach and consume data from a multi packets ust session with no
-       # discarded events. Enforce a server side limit on the stream data
-       # requests size. Ensure that babeltrace respect the returned size and that
-       # many requests per packet works as expected.
-       # The packet size of the test trace is 4k. Limit requests to 1k.
-       local test_text="CLI many requests per packet"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@/host/hostname/trace-with-index -c sink.text.details"
-       local sessions_file="$test_data_dir/rate_limited.json"
-       local server_args="--max-query-data-response-size 1024 --sessions-filename '$sessions_file'"
-       local expected_stdout="${test_data_dir}/cli-base.expect"
-       local expected_stderr
-
-       # Empty file for stderr expected
-       expected_stderr="$(mktemp -t test_live_rate_limited_stderr_expected.XXXXXX)"
-
-       run_test "$test_text" "$cli_args_template" "$server_args" "$expected_stdout" "$expected_stderr"
-
-       rm -f "$expected_stderr"
-}
-
-test_compare_to_ctf_fs() {
-       # Compare the details text sink or ctf.fs and ctf.lttng-live to ensure
-       # that the trace is parsed the same way.
-       # Do the same with the session swapped on the relayd side. This validate
-       # that ordering is consistent between live and ctf fs.
-       local test_text="CLI src.ctf.fs vs src.ctf.lttng-live"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@/host/hostname/multi-domains -c sink.text.details --params with-trace-name=false,with-stream-name=false"
-       local sessions_file="$test_data_dir/multi_domains.json"
-       local sessions_file_inverse="$test_data_dir/multi_domains_inverse.json"
-       local server_args="--sessions-filename '$sessions_file'"
-       local server_args_inverse="--sessions-filename '$sessions_file_inverse'"
-       local expected_stdout
-       local expected_stderr
-
-       expected_stdout="$(mktemp -t test_live_compare_stdout_expected.XXXXXX)"
-       expected_stderr="$(mktemp -t test_live_compare_stderr_expected.XXXXXX)"
-
-       bt_cli "$expected_stdout" "$expected_stderr" "${trace_dir}/succeed/multi-domains" -c sink.text.details --params "with-trace-name=false,with-stream-name=false"
-       bt_remove_cr "${expected_stdout}"
-       bt_remove_cr "${expected_stderr}"
-       run_test "$test_text" "$cli_args_template" "$server_args" "$expected_stdout" "$expected_stderr"
-       diag "Inverse session order from lttng-relayd"
-       run_test "$test_text" "$cli_args_template" "$server_args_inverse" "$expected_stdout" "$expected_stderr"
-
-       rm -f "$expected_stdout"
-       rm -f "$expected_stderr"
-}
-
-test_inactivity_discarded_packet() {
-       # Attach and consume data from a multi-packet trace with discarded
-       # packets and emit an inactivity beacon during the discarded packets
-       # period.
-       #
-       # | pkt seq:0 |<-------discarded packets------>| pkt seq:8 |
-       # 0          20                                121       140
-       #
-       # This test was introduced to cover the following bug:
-       #
-       # When reading this type of trace locally, the CTF source is expected
-       # to introduce a "Discarded packets" message between packets 0 and 8.
-       # The timestamps of this message are [pkt0.end_ts, pkt8.begin_ts].
-       #
-       # In the context of a live source, the tracer could report an inactivity
-       # period during the interval of the "Discarded packets" message.
-       # Those messages eventually translate into a
-       # "Iterator inactivity" message with a timestamp set at the end of the
-       # inactivity period.
-       #
-       # If the tracer reports an inactivity period that ends at a point
-       # between pkt0 and pkt7 (resulting in an "Iterator inactivity" message),
-       # the live source could send a "Discarded packets" message that starts
-       # before the preceding "Iterator inactivity" message. This would break
-       # the monotonicity constraint of the graph.
-       local test_text="CLI attach and fetch from single-domains session - inactivity discarded packet"
-       local cli_args_template="-i lttng-live net://localhost:@PORT@/host/hostname/7_lost_between_2_with_index -c sink.text.details"
-       local sessions_file="$test_data_dir/inactivity_discarded_packet.json"
-       local server_args="--sessions-filename '$sessions_file'"
-       local expected_stdout="$test_data_dir/inactivity_discarded_packet.expect"
-       local expected_stderr
-
-       # Empty file for stderr expected
-       expected_stderr="$(mktemp -t test_live_inactivity_discarded_packet_stderr_expected.XXXXXX)"
-
-       run_test "$test_text" "$cli_args_template" "$server_args" "$expected_stdout" "$expected_stderr"
-
-       rm -f "$expected_stderr"
-}
-
-plan_tests 14
-
-test_list_sessions
-test_base
-test_multi_domains
-test_rate_limited
-test_compare_to_ctf_fs
-test_inactivity_discarded_packet
This page took 0.026771 seconds and 4 git commands to generate.